/*
    Robot servo controller

    Sends contrller data to the server

    (C) 2004 Jason Hunt

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Contact: huntjas2@msu.edu

    Compile with -lwsock32

    FILE: display.cpp
*/


#include <windows.h>
#include "display.h"



// the data for textr display
char text_area[text_y_size][text_x_size];

// current y_pos in text buffer
int text_y = 0;

/* reset the text area */
void clear_text_area( void )
{
    memset(text_area, ' ', text_y_size * text_x_size);
}
/* end fo clear text area */


/* adds a line to the text buffer */
void add_line(char *line)
{
    // scrool the display up
    if (text_y == text_y_size)
    {
        for (int i = 1; i < text_y_size; i++)
            memcpy(text_area[i-1], text_area[i], text_x_size);
    }
    else
        text_y ++;

    // erase the line
    memset(text_area[text_y-1], ' ', text_x_size);

    // copy the string
    unsigned int line_len = strlen(line);

    if (line_len > text_x_size)
        line_len = text_x_size;

    memcpy(text_area[text_y-1], line, line_len);

    // force paint
    if (main_win != NULL)
        InvalidateRect (main_win, NULL, FALSE);
}
/* end of add line */



/* show the text buffer on the screen */
void display(void)
{
    PAINTSTRUCT paintStruct;
    HDC hdc = BeginPaint(main_win,&paintStruct);

    SelectObject(hdc, GetStockObject(SYSTEM_FIXED_FONT));

    for (int r = 0; r < text_y_size; r++)
        TextOut(hdc, 0, r * font_y_size, text_area[r], text_x_size);

    EndPaint(main_win, &paintStruct);
}
/* end of display_text_area */



















