/*
    Robot servo controller

    Sends contrller data to the server

    (C) 2004 Jason Hunt

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Contact: huntjas2@msu.edu

    Compile with -lwsock32

    FILE: key.cpp
*/


#include <windows.h>
#include "key.h"
#include "network.h"
#include "display.h"

int key_sp = 0;          // keep track of the position of the space key
int key_up = 0, key_dn = 0;
int key_lf = 0, key_rt = 0;


/* called when a key is pressed */
void process_key_down(WPARAM wParam)
{
    // escape key
    if (wParam == VK_ESCAPE) PostQuitMessage(0);

    // space is manual override


    int ch = 0; // keep track of changes in state

    if (wParam == VK_UP && !key_up) { key_up = 1; ch = 1; }
    if (wParam == VK_DOWN && !key_dn) { key_dn = 1; ch = 1; }
    if (wParam == VK_LEFT && !key_lf) { key_lf = 1; ch = 1; }
    if (wParam == VK_RIGHT && !key_rt) { key_rt = 1; ch = 1; }

    if (ch == 1)
    {
        if (key_up) { l_motor = 'F'; r_motor = 'F'; } else
        if (key_dn) { l_motor = 'R'; r_motor = 'R'; } else
        if (key_lf) { l_motor = 'R'; r_motor = 'F'; } else
        if (key_rt) { l_motor = 'F'; r_motor = 'R'; } else
            { l_motor = 'S'; r_motor = 'S'; }

        send_controller_values();
    }

       // if (wParam == VK_UP)    set_controller('F', 'F', 128, 128); else
       // if (wParam == VK_DOWN)  set_controller('R', 'R', 128, 128); else
       // if (wParam == VK_LEFT)  set_controller('R', 'F', 128, 128); else
       // if (wParam == VK_RIGHT) set_controller('F', 'R', 128, 128);
}
/* end of process key down */


/* called when a key is released */
void process_key_up( WPARAM wParam )
{
    int ch = 0; // keep track of changes in state

    if (wParam == VK_UP)    { key_up = 0; ch = 1; }
    if (wParam == VK_DOWN)  { key_dn = 0; ch = 1; }
    if (wParam == VK_LEFT)  { key_lf = 0; ch = 1; }
    if (wParam == VK_RIGHT) { key_rt = 0; ch = 1; }

    if (ch == 1)
    {
        if (key_up) { l_motor = 'F'; r_motor = 'F'; } else
        if (key_dn) { l_motor = 'R'; r_motor = 'R'; } else
        if (key_lf) { l_motor = 'R'; r_motor = 'F'; } else
        if (key_rt) { l_motor = 'F'; r_motor = 'R'; } else
            l_motor = 'S'; r_motor = 'S';

        send_controller_values();
    }
}
/* end of process key up */




