/*
    Robot servo controller

    Sends contrller data to the server

    (C) 2004 Jason Hunt

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Contact: huntjas2@msu.edu

    Compile with -lwsock32

    FILE: network.h
*/

#ifndef NETWORK_H
#define NWTWORK_H

#define PORT 1200
#define WM_NETEVENT WM_USER+1

#define rec_buffer_size 1024    // size of receive buffer

void startup_network(HWND hwnd);
void shutdown_network(void);
void network_message(WPARAM wParam,LPARAM lParam);
void send_controller_values();
void send_keep_alive( void );
void set_host_name(char *name);
void connect_to_server( void );
void connect(void);
void disconnect(void);
void get_servername( void );


extern HWND main_win;

extern char l_motor;
extern char r_motor;

extern unsigned char pan;
extern unsigned char tilt;

#endif


